<?php
namespace Teknisa\CADEST\Modules\Produto\Controllers;

use Teknisa\CADEST\Modules\Produto\Services\Produto as ProdutoService;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class TipoArvoreArvore extends \Teknisa\CADEST\Controllers\TeknisaCrud {

    protected $dataSourceName = "tparvoreprod_estruarvoreprod_para_arvore";

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions     = $filterCriteria->getConditions();

        //uncomment lines when Zeedhi Framework manage to get faster
        if(count($conditions) == 0) {
            $filterCriteria->addCondition("NRARVOREPRODPAI", "IS_NULL", null);
        }
        
        parent::find($request, $response);
        
        $dataSets = $response->getDataSets();
        
        if (count($dataSets) > 0) {
            $rows = $dataSets[0]->getRows();

            $rows = array_map(function($row) {
                $row['_hasChild'] = $row['HASCHILD'] === 'true' ? true : false;
                unset($row['HASCHILD']);
                return $row;
            }, $rows);

            $response->setDataSets(array(new DataSet('tparvoreprod_estruarvoreprod_para_arvore', $rows)));
        }
    }
}
