/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SISA                                                     */
/* Tabela : SINASAFRA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SISA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SISA
GO

CREATE TRIGGER DTULTATU_SISA
ON SINASAFRA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SINASAFRA', null, 'VRLIMINFSAFR='+ CONVERT(CHAR,VRLIMINFSAFR,103)+ ';'+
                                        'VRLIMSUPSAFR='+ CONVERT(CHAR,VRLIMSUPSAFR,103)+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SINASAFRA
      SET DTULTATUSISA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SINASAFRA.VRLIMINFSAFR,0) = ISNULL(INSERTED.VRLIMINFSAFR,0)) AND
            (ISNULL(SINASAFRA.VRLIMSUPSAFR,0) = ISNULL(INSERTED.VRLIMSUPSAFR,0)) AND
            (ISNULL(SINASAFRA.NMSINASAFRA,0)  = ISNULL(INSERTED.NMSINASAFRA,0))  AND
            (ISNULL(SINASAFRA.NRCORSINSAFR,0) = ISNULL(INSERTED.NRCORSINSAFR,0));
   END;
END;
GO

