<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class Apuragrupaval extends \Doctrine\ORM\EntityRepository {
    
    public function retornaResultadoColaboradorAgrupamentoRepository($params, $paramRelacionamento = false){
    $sqlResult = "SELECT ROUND(AVG(MEDIA_RELAC), 2) AS RESULTADO
                    FROM
                      (SELECT QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL AS PESORELAC,
                        AVG(RESPOSTA.VRPESORESPOSTA)  AS MEDIA_RELAC,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      FROM PARCNEGOCIO EXEC,
                        PARCNEGOCIO APLIC,
                        TIPORELACIONA,
                        QUESTAO,
                        RESPOSTA,
                        EXECAVALIACAO,
                        RESPAVALIACAO,
                        AVALIACAOGERAL,
                        PARTICIPAVAL,
                        COMBQUESTAVAL,
                        QUESTAVALIACAO,
                        TIPORELACAVAL,
                        AGRUPQUESTAVAL
                      WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                    --  AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                      AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                      AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                      AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                      AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                      AND EXECAVALIACAO.NRAVALIACAO      = AVALIACAOGERAL.NRAVALIACAO
                      AND AVALIACAOGERAL.NRAVALIACAO     = PARTICIPAVAL.NRAVALIACAO
                      AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                      AND (AVALIACAOGERAL.NRAVALIACAO    = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                      AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                      AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                      AND AVALIACAOGERAL.NRAVALIACAO     = TIPORELACAVAL.NRAVALIACAO
                      AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                      AND EXECAVALIACAO.NRORG            = PARTICIPAVAL.NRORG
                      AND EXECAVALIACAO.NRORG            = AVALIACAOGERAL.NRORG
                      AND EXECAVALIACAO.NRORG            = QUESTAO.NRORG
                      AND EXECAVALIACAO.NRORG            = RESPOSTA.NRORG
                      AND EXECAVALIACAO.NRORG            = EXEC.NRORG
                      AND EXECAVALIACAO.NRORG            = APLIC.NRORG
                      AND EXECAVALIACAO.NRORG            = QUESTAVALIACAO.NRORG
                      AND EXECAVALIACAO.NRORG            = RESPAVALIACAO.NRORG
                        /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                      AND RESPOSTA.VRPESORESPOSTA > -1";

        if ($paramRelacionamento) {
        $sqlResult .= "  AND QUESTAO.NRQUESTAO NOT IN
                        (SELECT QUESTAO.NRQUESTAO
                        FROM PARCNEGOCIO EXEC,
                          PARCNEGOCIO APLIC,
                          TIPORELACIONA,
                          QUESTAO,
                          RESPOSTA,
                          EXECAVALIACAO,
                          RESPAVALIACAO,
                          PARTICIPAVAL,
                          COMBQUESTAVAL,
                          QUESTAVALIACAO,
                          TIPORELACAVAL,
                          AGRUPQUESTAVAL
                        WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                        AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                        AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                        AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                        AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND PARTICIPAVAL.NRAVALIACAO       = :P_NRAVALIACAO
                        AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                        AND (:P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                        AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                        AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                        AND :P_NRAVALIACAO                 = TIPORELACAVAL.NRAVALIACAO
                        AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                        AND EXECAVALIACAO.NRORG            = PARTICIPAVAL.NRORG
                        AND EXECAVALIACAO.NRORG            = AVALIACAOGERAL.NRORG
                        AND EXECAVALIACAO.NRORG            = QUESTAO.NRORG
                        AND EXECAVALIACAO.NRORG            = RESPOSTA.NRORG
                        AND EXECAVALIACAO.NRORG            = EXEC.NRORG
                        AND EXECAVALIACAO.NRORG            = APLIC.NRORG
                        AND EXECAVALIACAO.NRORG            = QUESTAVALIACAO.NRORG
                        AND EXECAVALIACAO.NRORG            = RESPAVALIACAO.NRORG
                          /* filtra questoes que receberam resposta como NAO SE APLICA */
                        AND RESPOSTA.VRPESORESPOSTA        = -1
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                        AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                        AND EXECAVALIACAO.NRPARCEXECAVAL   = :P_NRPARCEXECAVAL
                        AND EXECAVALIACAO.NRORG            = :P_NRORG
                        AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                        )";
        }
        $sqlResult .= "  AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                      AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                      AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                      AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                      AND EXECAVALIACAO.NRPARCEXECAVAL   = :P_NRPARCEXECAVAL
                      AND EXECAVALIACAO.NRORG            = :P_NRORG
                      AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                      GROUP BY QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      ORDER BY QUESTAVALIACAO.NRQUESTAO)";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlResult, $params);
        return $result;
    }
    
    public function deleteApuragrupavalRepository($params){
        $sql = "DELETE FROM APURAGRUPAVAL WHERE NRPARTICIPAVAL = :P_NRPARTICIPAVAL AND NRORG = :P_NRORG";
        \Setforms2\Shared\Registry::getEntityManagerConnection()->executeQuery($sql, $params);
    }
    
    public function retornaAgrupamentosApurados($params){
        $sql = "SELECT *
                    FROM APURAGRUPAVAL
                    WHERE NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                    AND NRORG = :P_NRORG
                    AND NRPARTICIPAVAL    =
                      (SELECT NRPARTICIPAVAL
                      FROM PARTICIPAVAL
                      WHERE NRPARCAVALIADO = :P_NRPARCAVALIADO
                      AND NRPARCEXECAVAL   = :P_NRPARCEXECAVAL
                      AND NRAVALIACAO      = :P_NRAVALIACAO
                      AND NRORG = :P_NRORG
                      )";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        return $result;
    }
    
    public function retornaResultadoPonderadoAgrupamentoRepository($params, $paramRelacionamento = false){
    $sqlResult = "SELECT ROUND((SUM(SUM(MEDIA_RELAC) / SUM(PESORELAC)) / COUNT(NRQUESTAO)), 2) RESULTADO
                    FROM
                      (SELECT QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL                                    AS PESORELAC,
                        ( AVG(RESPOSTA.VRPESORESPOSTA) * TIPORELACAVAL.VRPESORELACAVAL ) AS MEDIA_RELAC,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      FROM PARCNEGOCIO EXEC,
                        PARCNEGOCIO APLIC,
                        TIPORELACIONA,
                        QUESTAO,
                        RESPOSTA,
                        EXECAVALIACAO,
                        RESPAVALIACAO,
                        AVALIACAOGERAL,
                        PARTICIPAVAL,
                        COMBQUESTAVAL,
                        QUESTAVALIACAO,
                        TIPORELACAVAL,
                        AGRUPQUESTAVAL
                      WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                      AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                      AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                      AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                      AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                      AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                      AND EXECAVALIACAO.NRAVALIACAO      = AVALIACAOGERAL.NRAVALIACAO
                      AND AVALIACAOGERAL.NRAVALIACAO     = PARTICIPAVAL.NRAVALIACAO
                      AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                      AND (AVALIACAOGERAL.NRAVALIACAO    = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                      AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                      AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                      AND AVALIACAOGERAL.NRAVALIACAO     = TIPORELACAVAL.NRAVALIACAO
                      AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                        /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                      AND RESPOSTA.VRPESORESPOSTA > -1";

    if ($paramRelacionamento) {
    $sqlResult .= "   AND QUESTAO.NRQUESTAO NOT    IN
                        (SELECT QUESTAO.NRQUESTAO
                        FROM PARCNEGOCIO EXEC,
                          PARCNEGOCIO APLIC,
                          TIPORELACIONA,
                          QUESTAO,
                          RESPOSTA,
                          EXECAVALIACAO,
                          RESPAVALIACAO,
                          PARTICIPAVAL,
                          COMBQUESTAVAL,
                          QUESTAVALIACAO,
                          TIPORELACAVAL,
                          AGRUPQUESTAVAL
                        WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                        AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                        AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                        AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                        AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND PARTICIPAVAL.NRAVALIACAO       = :P_NRAVALIACAO
                        AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                        AND (:P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                        AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                        AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                        AND :P_NRAVALIACAO                 = TIPORELACAVAL.NRAVALIACAO
                        AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                          /* filtra questoes que receberam resposta como NAO SE APLICA */
                        AND RESPOSTA.VRPESORESPOSTA = -1
                          /* filtra com o maior peso existente para a avaliacao*/
                        AND TIPORELACIONA.NRTIPORELACIONA IN
                          (SELECT TIPORELACIONA.NRTIPORELACIONA
                          FROM TIPORELACAVAL,
                            TIPORELACIONA
                          WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                          AND TIPORELACAVAL.VRPESORELACAVAL   =
                            (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
                            FROM TIPORELACAVAL
                            WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                            )
                          AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                          )
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                        AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                        AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                        )";
    }

    $sqlResult .= "   AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                      AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                      AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                      AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                      AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                      GROUP BY QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      ORDER BY QUESTAVALIACAO.NRQUESTAO
                      )
                    GROUP BY NRQUESTAO
                    ORDER BY NRQUESTAO";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlResult, $params);
        return $result;
    }
}