function TabelaPrecoController(ScreenService, General) {
    
    const MENSAGEM_VALIDA_PRECO = "Os valores de Preço e Preço Subsidiado não podem ter valor menor que zero.";
    
    var checkValorMenorQueZero = function(value){
        return value < 0;
    };
    
    this.onChangeFilial = function(args, fieldToReadOnly) {
        var field = args.owner.field;
        var widget = field.widget;
        
        if (field.value() !== undefined && field.value() != ''){
            widget.getField(fieldToReadOnly).readOnly = false;
        }else{
            widget.getField(fieldToReadOnly).readOnly = true;
            widget.getField(fieldToReadOnly).value(null);
        }
        widget.getField(fieldToReadOnly).value(null);
    };

	this.newPriceTag = function(args) {
		var widget = args.owner.widget;
		General.widgetNewRow(widget);
		widget.currentRow.NMPRODUTO = General.getFieldValue('NMPRODUTO', 'Detalhamento');
		widget.currentRow.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		widget.currentRow.CDARVPROD = General.getFieldValue('CDARVPROD', 'Detalhamento');
		if(Array.isArray(widget.appliedFilter) && (widget.appliedFilter.FILTER_ROW.CDFILIAL !== undefined && widget.appliedFilter.FILTER_ROW.CDFILIAL !== '' && widget.appliedFilter.FILTER_ROW.CDFILIAL !== null)){
			widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		}
		widget.getField('CDFILIAL').readOnly = false;
		widget.getField('CDTABEPREC').readOnly = false;
		widget.reload();
	};
	
	
	
	this.parseStrToFloat = function (value) {
		if(!!value) {
	    	value = String(value);
	    	var numberOfDots = (value.match(/\./g) || []).length,
	        	hasVirgula   = !!(value.match(/\,/g) || []).length;
	    	
	    	if(hasVirgula) {
	    	    if(!!numberOfDots) {
	        		value = value.replace(/\./g, "");
	        	}
	    	    
	    	    value = value.replace(",", ".");
	    	}
	    } else {
	    	value = 0.00;
	    }
	    
	    return parseFloat(value);
	};

	this.savePriceTag = function(widget) {
		widget.currentRow.NRORG = getLocalVar('NRORG');
		widget.currentRow.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		widget.currentRow.CDPRPAITABPR = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		 widget.currentRow.VRPRECITEM = this.parseStrToFloat(widget.currentRow.VRPRECITEM);
		widget.currentRow.VRPRESUGITEM = this.parseStrToFloat(widget.currentRow.VRPRESUGITEM);
		widget.currentRow.VRPRECITEMCL = this.parseStrToFloat(widget.currentRow.VRPRECITEMCL);
		widget.currentRow.VRCUSTITEM = this.parseStrToFloat(widget.currentRow.VRCUSTITEM);
		General.widgetSave(widget).then(function(){
            ScreenService.closeSwipe();
		    widget.reload();
		});
	};
	
	this.editPriceTag = function(args) {
		var widget = args.owner.widget;
		General.widgetEdit(widget);
		var CurrentRow = widget.currentRow;
		CurrentRow.CDFILIAL = Array.isArray(CurrentRow.CDFILIAL) ? CurrentRow.CDFILIAL : [CurrentRow.CDFILIAL];
		CurrentRow.CDTABEPREC = Array.isArray(CurrentRow.CDTABEPREC) ? CurrentRow.CDTABEPREC : [CurrentRow.CDTABEPREC];
		CurrentRow.NMTABEPREC = Array.isArray(CurrentRow.NMTABEPREC) ? CurrentRow.NMTABEPREC : [CurrentRow.NMTABEPREC];
		CurrentRow.CDFILIALTAB = Array.isArray(CurrentRow.CDFILIAL) ? CurrentRow.CDFILIAL : [CurrentRow.CDFILIAL];
		CurrentRow.DTFINVGPREC = Array.isArray(CurrentRow.DTFINVGPREC) ? CurrentRow.DTFINVGPREC : [CurrentRow.DTFINVGPREC];
		CurrentRow.DTINIVGPREC = Array.isArray(CurrentRow.DTINIVGPREC) ? CurrentRow.DTINIVGPREC : [CurrentRow.DTINIVGPREC];
		widget.getField('CDFILIAL').reload();
		widget.getField('CDTABEPREC').reload();
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('TabelaPrecoController', TabelaPrecoController);
});